package org.dd4t.thymeleaf.dialect.image;

import java.util.HashSet;
import java.util.Set;

import javax.annotation.Resource;

import org.dd4t.core.services.PropertiesService;
import org.dd4t.thymeleaf.dialect.image.processor.BinaryAttrProcessor;
import org.dd4t.thymeleaf.dialect.image.processor.SizedImageFactory;
import org.springframework.context.MessageSource;
import org.thymeleaf.dialect.IProcessorDialect;
import org.thymeleaf.processor.IProcessor;

public class BinaryDialect implements IProcessorDialect {

    @Resource
    PropertiesService propertiesService;

    @Resource
    MessageSource messageSource;

    @Resource
    private SizedImageFactory sizedImageFactory;

    public BinaryDialect() {
    }

    /**
     * Prefix of the dialect.
     */
    @Override
    public String getPrefix() {
        return "bin";
    }

    /**
     * Available processors
     */
    @Override
    public Set<IProcessor> getProcessors(String dialectPrefix) {
        final Set<IProcessor> processors = new HashSet<IProcessor>();
        processors.add(new BinaryAttrProcessor(getPrefix(), sizedImageFactory));
        return processors;
    }

    @Override
    public String getName() {
        return "DD4T Binary Dialect";
    }

    @Override
    public int getDialectProcessorPrecedence() {
        return 0;
    }

}