package org.dd4t.thymeleaf.dialect.image.processor;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.logging.Level;
import java.util.logging.Logger;


public final class MD5 {
    private static final Logger LOG = Logger.getLogger(MD5.class.getName());

    public static String hash(String md5) {
        return hash(md5, "MD5");
    }

    public static String hash(String md5, String type) {
        try {
            MessageDigest md = MessageDigest.getInstance(type);
            byte[] array = md.digest(md5.getBytes());
            StringBuffer sb = new StringBuffer();
            for (int i = 0; i < array.length; i++) {
                sb.append(Integer.toHexString((array[i] & 0xFF) | 0x100).substring(1, 3));
            }
            return sb.toString();
        } catch (NoSuchAlgorithmException e) {
            LOG.log(Level.SEVERE, e.getMessage(), e);
        }
        return null;
    }
}